#Include Once "win\gdiplus.bi"
Using GDIPLUS

Extern "Windows-MS"

Declare Function GetRandom(As Integer, As Integer) As Integer

'Returns a random number between low and high
Function GetRandom(iLowerbound As Integer, iUpperbound As Integer) As Integer
	GetRandom = Int((iUpperbound - iLowerbound + 1) * Rnd + iLowerbound)
End Function

Sub RandomPattern(ByVal hBitmap As GpImage Ptr, iW As UInteger, iH As UInteger, iRndLow As Integer = 0, iRndHigh As Integer = &hFFFFFF, iAlpha As UInteger = &hFF000000) Export
	Dim As Integer iX, iY, iColor 
	
	For iY = 0 To iH
		For iX = 0 To iW
			iColor = iAlpha + GetRandom(iRndLow, iRndHigh)
			GdipBitmapSetPixel(hBitmap, iX, iY, iColor)
		Next 
	Next
	
End Sub

End Extern